<template>
    <div class="page-container">
        <h3 class="mb-0">
            Discount Links
        </h3>
        <div class="d-flex justify-content-end">
            <router-link
                :to="{name: 'discount-add'}"
                class="btn btn-primary btn_add"
            >
                Add
            </router-link>
        </div>
        <div
            :class="{'loading-md': loading}"
        >
            <Table
                v-if="!loading && items.length"
                :items="items"
                :fields="fields"
                :loading="loading"
                @onDelete="onDelete"
            />
            <span v-else-if="!loading">No Discount Links</span>
        </div>
    </div>
</template>

<script>
import api from '../../services/discount.service'
import Table from '../../components/discount-links/Table.vue'

export default {
  components: {
    Table
  },
  data() {
    return {
        loading: true,
        items: null,
        fields: [
            'code',
            'discount',
            'expires_at',
            'link',
            'actions',
        ],
    }
  },
  created() {
    this.loadItems()
  },
  methods: {
    async loadItems() {
      if(!this.loading) this.loading = true
      this.items = await api.getItems()
      this.loading = false
    },
    async onDelete(id) {
      const question = confirm("Are you sure you want to delete this record?")
      if(question) {
        await api.deleteItem(id)
        this.loadItems()
      }
    }
  },
}
</script>

<style lang="scss" scoped>
.btn {
  &_add {
    margin: 10px 0 10px auto;
  }
}
.page-container {
  padding-top: 40px;
  @media(max-width: 770px) {
    padding-top: 80px;
  }
}
</style>

